//
//  MenuItems.h
//  FMenu
//
//  Created by Paul Borokhov on 1/5/07.
//  Copyright 2007 Paul Borokhov. All rights reserved.
/*
 **
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * FMenu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#import <Cocoa/Cocoa.h>
#import <Controller.h>
#import "MenuItemUpdate.h"

@interface Controller (MenuItems)

#pragma mark -
#pragma mark Updating UI on main thread
- (void)updateMenuItem:(id)anUpdate;

#pragma mark Menu Items

- (IBAction)goToMessages:(id)sender;
- (IBAction)goToHome:(id)sender;
- (IBAction)goToWall:(id)sender;
- (IBAction)goToEvents:(id)sender;
- (IBAction)goToReqs:(id)sender;
- (IBAction)goToPokes:(id)sender;
- (IBAction)goToFriends:(id)sender;

- (IBAction)forceUpdate:(id)sender;
- (IBAction)showQL:(id)sender;

- (IBAction)showAbout:(id)sender;
- (IBAction)showReadMe:(id)sender;
- (IBAction)showPreferences:(id)sender;

#pragma mark Home submenu items
- (void)createSubmenus;
- (IBAction)goToProfile:(id)sender;
- (IBAction)goToPhotos:(id)sender;
- (IBAction)goToPhotosAbout:(id)sender;
- (IBAction)goToPhotosOfFriends:(id)sender;
- (IBAction)goToPhotosRecentlyTagged:(id)sender;
- (IBAction)goToSharesPosted:(id)sender;
- (IBAction)goToSharesOfFriends:(id)sender;
- (IBAction)goToNotes:(id)sender;
- (IBAction)goToNotesAbout:(id)sender;
- (IBAction)goToNotesOfFriends:(id)sender;
- (IBAction)goToGroups:(id)sender;
- (IBAction)goToGroupsUpdated:(id)sender;
- (IBAction)goToGroupsAdmin:(id)sender;
- (IBAction)goToGroupsSecret:(id)sender;
- (IBAction)goToGroupsSponsored:(id)sender;
- (IBAction)goToMobile:(id)sender;
- (IBAction)goToAccount:(id)sender;
- (IBAction)goToPrivacy:(id)sender;

- (BOOL)validateMenuItem:(NSMenuItem *)menuItem;
@end
