//
//  TimerFunctions.m
//  FMenu
//
//  Created by Paul Borokhov on 1/5/07.
//  Copyright 2007 Paul Borokhov. All rights reserved.
/*
 **
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * FMenu is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#import "TimerFunctions.h"
#define UPDATESINTERVAL 86400.0


@implementation Controller (TimerFunctions)

-(void)startTimer:(int)delay {
	[timer invalidate];
	[[NSRunLoop currentRunLoop] cancelPerformSelectorsWithTarget:self];
	@try {
		timer = [[NSTimer alloc] initWithFireDate:[NSDate dateWithTimeIntervalSinceNow:delay] interval:[[NSUserDefaults standardUserDefaults] integerForKey:@"updateTime"] target:self selector:@selector(getCountsWithTimer:) userInfo:nil repeats:YES];
		[[NSRunLoop currentRunLoop] addTimer:timer forMode:NSDefaultRunLoopMode];
	} @catch (NSException * e) {
		if ([[[NSUserDefaultsController sharedUserDefaultsController] defaults] boolForKey:@"logErrors"]) {
			NSLog(@"%@", [e reason]);
		}
	}
	//[[NSRunLoop currentRunLoop] addTimer:[[NSTimer alloc] initWithFireDate:[NSDate dateWithTimeIntervalSinceNow:0] interval:UPDATESINTERVAL target:self selector:@selector(checkForUpdates:) userInfo:nil repeats:YES] forMode:NSDefaultRunLoopMode];
}

-(void)restartTimers {
	[self startTimer:(noOfChecks*firstSleepInterval+[[NSUserDefaults standardUserDefaults] integerForKey:@"updateTime"])];
}

- (IBAction)reset:(id)sender {
	if ([facebook userLoggedIn]) {
		[self doLogout:YES];
	} else {
		[self doLogin];
	}
}

-(void)doLogin {
	if (facebook == nil) {
		[self initFacebook];
	} else {
		if (![facebook userLoggedIn]) {
			[NSApp activateIgnoringOtherApps:YES];
			[facebook showFacebookLoginWindow];
		}
	}
}
-(void)doLogout:(BOOL)fromMenu {
	if (facebook == nil) {
		// why would this ever be taken?
		[self initFacebook];
	} else {
		[timer invalidate];
		[[NSRunLoop currentRunLoop] cancelPerformSelectorsWithTarget:self];
		if ([facebook userLoggedIn]) {
			[facebook resetFacebookConnection];
		}
		[self setLoginMenuItemText];
		// comply with TOS
		[oldData release];
		oldData = nil;
		[quicklaunchArray removeAllObjects];
		[idDic removeAllObjects];
		[namesArray removeAllObjects];
		[namesDic removeAllObjects];
		[eventsArray removeAllObjects];
		[eventsDic removeAllObjects];
		[groupsArray removeAllObjects];
		[groupsDic removeAllObjects];
		[nameSearch reloadData];
		// reset all counters
		[self setCounters];
		[self updateCount:0];
		[self setMenuImage:self];
	}
}

@end
